6 # I use this in EVERY shell script ;)
11 while ! [ -f ./all ]; do
12 if [ x"`pwd`" = x"/" ]; then
13 echo "Cannot find myself."
14 echo "Please run this script with the working directory inside a Xonotic checkout."
22 # If we are on WINDOWS:
27 # Windows hates users. So this script has to copy itself elsewhere first...
28 cp "$SELF" ../all.xonotic.sh
29 export WE_HATE_OUR_USERS=1
30 exec ../all.xonotic.sh "$@"
41 self=`git hash-object "$SELF"`
44 self_new=`git hash-object "$SELF"`
45 if [ x"$self" != x"$self_new" ]; then
46 msg "./all has changed."
47 if [ -z "$XONOTIC_FORBID_RERUN_ALL" ]; then
48 msg "Rerunning the requested operation to make sure."
49 export XONOTIC_FORBID_RERUN_ALL=1
52 msg "Please try $SELF update, and then retry your requested operation."
69 echo "the root directory"
79 if git ls-files -u | grep ' 1 '; then
81 echo "MERGE CONFLICT."
82 echo "change into the \"$1\" project directory, and then:"
83 echo "- edit the files mentioned above with your favorite editor,"
84 echo " and fix the conflicts (marked with <<<<<<< blocks)"
85 echo "- for binary files, you can select the files using"
86 echo " git checkout --ours or git checkout --theirs"
87 echo "- when done with a file, 'git add' the file"
88 echo "- when done, 'git commit'"
97 while [ x"$yesno" != x"y" -a x"$yesno" != x"n" ]; do
108 check_mergeconflict "$1"
113 data/xonotic-data.pk3dir | | master |
114 data/xonotic-maps.pk3dir | | master |
115 data/xonotic-music.pk3dir | | master |
116 data/xonotic-nexcompat.pk3dir | | master |
117 mediasource | | master |
118 darkplaces | | div0-stable | svn
119 fteqcc | git://github.com/Blub/qclib.git | master |
120 div0-gittools | | master |
121 netradiant | | master |
123 # todo: in darkplaces, change repobranch to div0-stable
125 repos=`echo "$repos_urls" | grep . | cut -d '|' -f 1 | tr -d ' '`
127 base=`git config remote.origin.url`
130 base=${base%xonotic.git}
133 echo "The main repo is not xonotic.git, what have you done?"
140 repo_t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 2 | tr -d ' '`
141 if [ -n "$repo_t" ]; then
151 if [ x"$1" = x"." ]; then
152 echo "$base""xonotic.git"
154 echo "$base${1##*/}.git"
161 repo_t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 3 | tr -d ' '`
162 if [ -n "$repo_t" ]; then
171 echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 4 | tr -d ' '
174 repos=`for d in $repos; do
176 if [ x"$p" = x"$d" ] || [ -d "$d" ] || ! { [ -f "$d.no" ] || [ -f "$p" ]; }; then
181 if [ "$#" = 0 ]; then
190 if [ x"$1" = x"-N" ]; then
195 branch=`repobranch "$d"`
196 if [ -d "$d0/$d" ]; then
198 enter "$d0/$d" verbose
199 verbose git config remote.origin.url "$url"
200 verbose git config remote.origin.fetch "+refs/heads/*:refs/remotes/origin/*"
202 verbose git config remote.origin.autocrlf input
204 r=`git symbolic-ref HEAD`
206 if git config branch.$r.remote >/dev/null 2>&1; then
207 if ! verbose git pull; then
208 check_mergeconflict "$d"
209 echo "Pulling failed. Press ENTER to continue, or Ctrl-C to abort."
215 checkself "$cmd" "$@"
217 verbose git remote prune origin
221 verbose git clone "$url" "$d0/$d"
222 enter "$d0/$d" verbose
223 if [ "$branch" != "master" ]; then
224 verbose git checkout --track -b "$branch" origin/"$branch"
231 misc/tools/xonotic-map-compiler-autobuild download
236 if [ -z "$branch" ]; then
239 branch=${remote#origin/}
250 enter "$d0/$d" verbose
252 if [ -n "$b" ] && git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
254 verbose git checkout "$b"
255 elif [ -n "$b" ] && git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
257 verbose git checkout --track -b "$b" "$remote/$b"
260 if git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
262 verbose git checkout "$b"
263 elif git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
265 verbose git checkout --track -b "$b" "$remote/$b"
267 echo "WTF? Not even branch $b doesn't exist in $d"
272 checkself "$cmd" "$@"
276 echo "The requested branch was not found in any repository."
284 if [ -z "$branch" ]; then
288 if [ -z "$branch" ]; then
291 r=`git symbolic-ref HEAD`
298 dv=`visible_repo_name "$d"`
299 enter "$d0/$d" verbose
300 if git rev-parse "refs/heads/$branch" >/dev/null 2>&1; then
301 echo "Already having this branch in $dv."
303 if yesno "Branch in $dv?"; then
304 if [ -n "$srcbranch" ]; then
307 b=origin/"`repobranch "$d"`"
308 verbose git fetch origin || true
310 # TODO do this without pushing
311 verbose git checkout -b "$branch" "$b"
312 verbose git config "branch.$branch.remote" "$remote"
313 verbose git config "branch.$branch.merge" "refs/heads/$branch"
323 cd "$d0/$d" # am in a pipe, shouldn't use enter
324 git branch -a -v -v | cut -c 3- | sed "s/^(no branch)/(no_branch)/" | sed "s,^,$d ,"
329 while read -r d BRANCH REV UPSTREAM TEXT; do
330 if [ x"$BRANCH" = x"`repobranch "$d"`" ]; then
335 UPSTREAM=${UPSTREAM#\[}
336 UPSTREAM=${UPSTREAM%\]}
337 UPSTREAM=${UPSTREAM%:*}
340 TEXT="$UPSTREAM $TEXT"
344 if [ x"$REV" = x"->" ]; then
347 BRANCH=${BRANCH#remotes/}
348 ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
349 branches_list="$branches_list $BRANCH" # TEH SORT MAKEZ IT UNIEQ
350 eval "r=\$branches_repos_$ID"
359 eval "branches_repos_$ID=\$r"
361 echo -n "$branches_list" | xargs -n 1 echo | sort -u | while IFS= read -r BRANCH; do
362 ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
363 eval "r=\$branches_repos_$ID"
364 printf "%-60s %s\n" "$BRANCH" "$r"
371 dv=`visible_repo_name "$d"`
372 enter "$d0/$d" verbose
373 r=`git symbolic-ref HEAD`
375 if git log HEAD..origin/"`repobranch "$d"`" | grep .; then
376 # we have uncommitted changes
377 if yesno "Could merge from \"`repobranch "$d"`\" into \"$r\" in $dv. Do it?"; then
378 if ! verbose git merge origin/"`repobranch "$d"`"; then
379 check_mergeconflict "$d"
380 exit 1 # this should ALWAYS be fatal
390 dv=`visible_repo_name "$d"`
391 enter "$d0/$d" verbose
392 r=`git symbolic-ref HEAD`
394 diffdata=`git diff --color HEAD`
395 if [ -n "$diffdata" ]; then
396 # we have uncommitted changes
397 if yesno "Uncommitted changes in \"$r\" in $dv. Commit?" 'echo "$diffdata" | less -r'; then
398 verbose git commit -a
401 rem=`git config "branch.$r.remote" || echo origin`
402 bra=`git config "branch.$r.merge" || echo "$r"`
403 upstream="$rem/${bra#refs/heads/}"
404 if ! git rev-parse "$upstream" >/dev/null 2>&1; then
405 upstream="origin/`repobranch "$d"`"
407 logdata=`git log --color "$upstream".."$r"`
408 if [ -n "$logdata" ]; then
409 if yesno "Push \"$r\" in $dv?" 'echo "$logdata" | less -r'; then
410 verbose git push "$rem" HEAD
413 if [ x"$submit" = x"-s" ]; then
416 verbose git push "$rem" HEAD:"${bra%%/*}/finished/${bra#*/}"
424 if [ -n "$WE_HATE_OUR_USERS" ]; then
425 TARGETS="sv-debug cl-debug"
426 if [ -z "$CC" ]; then
429 elif [ x"`uname`" = x"Darwin" ]; then
432 TARGETS="sv-debug cl-debug sdl-debug"
435 # AGL cannot be compiled on systems with a kernel > 10.x (Snow Leopard)
436 TARGETS="sv-debug sdl-debug"
439 export CC="gcc -I$PWD/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks/SDL.framework/Headers -F$PWD/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks"
441 TARGETS="sv-debug cl-debug sdl-debug"
459 cleanqc=true # version info
462 if [ $# -gt 0 ] && [ x"$1" = x"" ]; then
463 # if we give the command make the arg "", it will surely fail (invalid filename),
464 # so better handle it as an empty client option
467 elif [ -n "$1" ]; then
469 TARGETS_SAVE=$TARGETS
474 TARGETS="$TARGETS sdl-debug"
477 TARGETS="$TARGETS cl-debug"
480 TARGETS="$TARGETS sv-debug"
483 BAD_TARGETS="$BAD_TARGETS $X"
487 if [ -n "$TARGETS" ]; then # at least a valid client
489 else # no valid client, let's assume this option is not meant to be a client then
490 TARGETS=$TARGETS_SAVE
494 if [ -z "$MAKEFLAGS" ]; then
495 if [ -f /proc/cpuinfo ]; then
496 ncpus=$((`grep -c '^processor :' /proc/cpuinfo`+0))
497 if [ $ncpus -gt 1 ]; then
503 MAKEFLAGS="$MAKEFLAGS DP_LINK_TO_LIBJPEG=1"
506 if [ -n "$WE_HATE_OUR_USERS" ]; then
507 MAKEFLAGS="$MAKEFLAGS DP_MAKE_TARGET=mingw"
511 enter "$d0/fteqcc" verbose
513 verbose make $MAKEFLAGS clean
515 verbose make $MAKEFLAGS
517 enter "$d0/data/xonotic-data.pk3dir" verbose
519 verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS clean
521 verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS
523 enter "$d0/darkplaces" verbose
524 if [ x"$BAD_TARGETS" = x" " ]; then
525 echo "Warning: invalid empty client, default clients will be used."
528 verbose make $MAKEFLAGS clean
530 for T in $TARGETS; do
531 verbose make $MAKEFLAGS "$@" "$T"
533 for T in $BAD_TARGETS; do
534 echo "Warning: discarded invalid client $T."
537 verbose "$SELF" update-maps
540 if [ -n "$WE_HATE_OUR_USERS" ]; then
542 export PATH="$d0/misc/buildfiles/win64:$d0/misc/buildfiles/win32:$PATH"
543 elif [ x"`uname`" = x"Darwin" ]; then
544 export DYLD_LIBRARY_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/MacOS"
545 export DYLD_FRAMEWORK_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks"
551 sdl|glx|agl|dedicated)
560 if ! [ -x "darkplaces/darkplaces$client" ]; then
561 if [ -x "darkplaces/darkplaces$client.exe" ]; then
564 echo "Client darkplaces/darkplaces$client not found, aborting"
568 set -- "darkplaces/darkplaces$client" -nexuiz -customgamename Xonotic -customgamedirname1 data -customgamedirname2 "" -customgamescreenshotname xonotic -customgameuserdirname xonotic -mygames "$@"
570 # if pulseaudio is running: USE IT
571 if [ -z "$SDL_AUDIODRIVER" ] && ! [ -n "$WE_HATE_OUR_USERS" ] && ! [ x"`uname`" = x"Darwin" ]; then
572 if ps -C pulseaudio >/dev/null; then
573 if ldd /usr/lib/libSDL.so 2>/dev/null | grep pulse >/dev/null; then
574 export SDL_AUDIODRIVER=pulse
579 if [ -n "$USE_GDB" ]; then
580 set -- gdb --args "$@"
586 if [ x"$1" = x"-k" ]; then
591 if verbose cd "$d0/$d"; then
603 patchdir=`mktemp -d -t save-patches.XXXXXX`
605 enter "$d0/$d" verbose
606 git branch -v -v | cut -c 3- | {
608 while read -r BRANCH REV UPSTREAM TEXT; do
611 UPSTREAM=${UPSTREAM#\[}
612 UPSTREAM=${UPSTREAM%\]}
613 UPSTREAM=${UPSTREAM%:*}
617 UPSTREAM=origin/"`repobranch "$d"`"
621 if [ x"$REV" = x"->" ]; then
624 if git format-patch -o "$patchdir/$i" "$UPSTREAM".."$BRANCH"; then
625 echo "$d" > "$patchdir/$i/info.txt"
626 echo "$BRANCH" >> "$patchdir/$i/info.txt"
627 echo "$UPSTREAM" >> "$patchdir/$i/info.txt"
628 echo "$TRACK" >> "$patchdir/$i/info.txt"
631 rm -rf "$patchdir/$i"
636 ( cd "$patchdir" && tar cvzf - . ) > "$outfile"
641 patchdir=`mktemp -d -t restore-patches.XXXXXX`
642 ( cd "$patchdir" && tar xvzf - ) < "$infile"
644 for P in "$patchdir"/*/info.txt; do
651 verbose git checkout HEAD^0
652 verbose git branch -D "$BRANCH"
653 if [ x"$TRACK" = x"true" ]; then
654 verbose git checkout --track -b "$BRANCH" "$UPSTREAM"
656 verbose git branch -b "$BRANCH" "$UPSTREAM"
668 report=$report"$*$LF"
673 report=$report" $*$LF"
678 o=`"$@" | sed 's/^/ /' || true`
682 enter "$d0/$d" verbose
683 base="`repobranch "$d"`"
685 for ref in `git for-each-ref --format='%(refname)' refs/remotes/origin/`; do
686 case "${ref#refs/remotes/origin/}" in
699 if [ -n "$branch" ]; then
700 if [ x"$branch" != x"${ref#refs/remotes/origin/}" ]; then
709 l0=`git rev-list "$base".."$ref" | wc -l`
710 l1=`git rev-list master.."$ref" | wc -l`
711 if [ $l0 -gt $l1 ]; then
718 reportecho " Branch $ref:"
719 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
720 logdata=`git log --color "$realbase".."$ref"`
721 if [ -z "$logdata" ]; then
722 reportecho4 "--> not merging, no changes vs master"
723 if yesno "Branch \"$ref\" probably should get deleted. Do it?" ''; then
724 git push origin :"${ref#refs/remotes/origin/}"
725 reportecho4 "--> branch deleted"
728 diffdata=`git diff --color --find-copies-harder --ignore-space-change "$realbase"..."$ref"`
729 if [ -z "$diffdata" ]; then
730 reportecho4 "--> not merging, no changes vs master, branch contains redundant history"
731 if yesno "Branch \"$ref\" probably should get deleted. Do it?" '{ echo "$logdata"; } | less -r'; then
732 git push origin :"${ref#refs/remotes/origin/}"
733 reportecho4 "--> branch deleted"
735 elif [ -z "$branch" ] && [ -n "$note" ]; then
736 reportdo4 echo "$note"
737 reportecho4 "--> not merging, already had this one rejected before"
738 elif yesno "Branch \"$ref\" may want to get merged. Do it?" '{ echo "$logdata"; echo "$diffdata"; } | less -r'; then
739 git checkout "$realbase"
740 org=`git rev-parse HEAD`
741 if ! git merge --no-ff "$ref" 2>&1 | tee "$t" && ! { git ls-files -u | grep ' 1 ' >/dev/null; }; then
742 git reset --hard "$org"
743 GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Merge failed:$LF`cat "$t"`" "$ref"
745 reportecho4 "--> merge failed"
746 elif ! "$SELF" compile -n 2>&1 | tee "$t"; then
747 git reset --hard "$org"
748 GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Compile failed:$LF`cat "$t"`" "$ref"
750 reportecho4 "--> compile failed"
751 elif ! yesno "Still merge \"$ref\" into `git symbolic-ref HEAD` of $d? Maybe you want to test first."; then
752 git reset --hard "$org"
753 GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
754 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
755 if [ x"$note" = x"del" ]; then
756 git push origin :"${ref#refs/remotes/origin/}"
757 reportecho4 "--> test failed, branch deleted"
758 elif [ -n "$note" ]; then
759 reportdo4 echo "$note"
760 reportecho4 "--> test failed"
762 reportecho4 "--> test failed, postponed"
766 case ",`repoflags "$d"`," in
768 # we do quite a mess here... luckily we know $org
769 git fetch # svn needs to be current
770 git rebase -i --onto origin/master "$org"
771 git svn dcommit --add-author-from
772 git reset --hard "$org"
778 reportecho4 "--> MERGED"
779 if yesno "Delete original branch \"$ref\"?"; then
780 git push origin :"${ref#refs/remotes/origin/}"
781 reportecho4 "--> branch deleted"
785 GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
786 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
787 if [ x"$note" = x"del" ]; then
788 git push origin :"${ref#refs/remotes/origin/}"
789 reportecho4 "--> branch deleted"
790 elif [ -n "$note" ]; then
791 reportdo4 echo "$note"
792 reportecho4 "--> rejected"
794 reportecho4 "--> postponed"
803 echo "$report" | ssh nexuiz@rm.endoftheinternet.org cat '>>' public_html/xonotic-merge-notes.txt
806 # release building goes here
808 mkdir -p Xonotic/"$1"
811 #"$SELF" each git clean -fxd
813 "$SELF" release-copy Docs/
814 "$SELF" release-copy misc/
815 "$SELF" release-copy server/
816 "$SELF" release-copy xonotic-linux-glx.sh
817 "$SELF" release-copy xonotic-linux-sdl.sh
818 "$SELF" release-mkdir data
819 "$SELF" release-mkdir fteqcc
822 rsync --exclude=.git -vaSHPAX "$1" Xonotic/"$1"
831 rsync --delete -zvaSHPAX "$srcdir"/ "$host:$buildpath/"
832 ssh "$host" ". ~/.profile && cd $buildpath && make clean $maketargets $makeflags"
833 for f in $targetfiles; do
834 rsync -zvaSHPAX "$host:$buildpath/${f%:*}" "${f##*:}"
840 fteqcc_maketargets=$3
842 darkplaces_maketargets=$5
844 "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/fteqcc.build."$suffix" "$fteqcc_maketargets" "$makeflags" "fteqcc" "$fteqcc_files"
845 "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/Darkplaces.build."$suffix" "$darkplaces_maketargets" "$makeflags" "fteqcc" "$darkplaces_files"
847 release-engine-win32)
848 rsync --exclude=.git -vaSHPAX Xonotic/misc/buildfiles/win32/* Xonotic/
849 "$SELF" release-compile win32 \
850 '"DP_MAKE_TARGET=mingw CC="i586-mingw32msvc-gcc -Wl,--dynamicbase -Wl,--nxcompat -g -DSUPPORTDIRECTX -DUSE_WSPIAPI_H -I$HOME/dp.win32/include -L$HOME/dp.win32/lib" WINDRES="i586-mingw32msvc-windres" SDL_CONFIG="$HOME/dp.win32/bin/sdl-config"' \
851 win 'fteqcc.exe:Xonotic/fteqcc/fteqcc.exe' \
852 debug 'darkplaces.exe:xonotic.exe darkplaces-sdl.exe:xonotic-sdl.exe darkplaces-dedicated.exe:xonotic-dedicated.exe'
854 release-engine-win64)
855 rsync --exclude=.git -vaSHPAX Xonotic/misc/buildfiles/win64/* Xonotic/
856 "$SELF" release-compile win32 \
857 '"DP_MAKE_TARGET=mingw CC="amd64-mingw32msvc-gcc -Wl,--dynamicbase -Wl,--nxcompat -g -DSUPPORTDIRECTX -DUSE_WSPIAPI_H -I$HOME/dp.win64/include -L$HOME/dp.win64/lib" WINDRES="amd64-mingw32msvc-windres" SDL_CONFIG="$HOME/dp.win64/bin/sdl-config"' \
858 win 'fteqcc.exe:Xonotic/fteqcc/fteqcc-64.exe' \
859 debug 'darkplaces.exe:xonotic-64.exe darkplaces-sdl.exe:xonotic-sdl-64.exe darkplaces-dedicated.exe:xonotic-dedicated-64.exe'
862 rsync --exclude=.git -vaSHPAX Xonotic/misc/buildfiles/osx/* Xonotic/
863 "$SELF" release-compile osx \
864 'CC="gcc -g -arch i386 -arch ppc -arch x86_64 -isysroot /Developer/SDKs/MacOSX10.5.sdk -mmacosx-version-min=10.5 -I$HOME/dp.osx/include -L$HOME/dp.osx/lib"' \
865 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.osx' \
866 sdl-debug 'darkplaces-sdl:Xonotic/Xonotic-SDL.app/Contents/MacOS/xonotic-osx-sdl-bin'
868 release-engine-linux32)
869 "$SELF" release-compile linux32 \
870 'CC="gcc -m32 -g -Wl,--hash-style=sysv -I$HOME/dp.linux32/include -L$HOME/dp.linux32/lib" DP_MODPLUG_STATIC_LIBDIR=$HOME/dp.linux32/lib DP_LINK_TO_LIBJPEG=1' \
871 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux32' \
872 debug 'darkplaces-glx:Xonotic/xonotic-linux-linux32-glx darkplaces-sdl:Xonotic/xonotic-linux32-sdl darkplaces-dedicated:Xonotic/xonotic-linux32-dedicated'
874 release-engine-linux64)
875 "$SELF" release-compile linux64 \
876 'CC="gcc -m64 -g -Wl,--hash-style=sysv -I$HOME/dp.linux64/include -L$HOME/dp.linux64/lib" DP_MODPLUG_STATIC_LIBDIR=$HOME/dp.linux64/lib DP_LINK_TO_LIBJPEG=1' \
877 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux64' \
878 debug 'darkplaces-glx:Xonotic/xonotic-linux-linux64-glx darkplaces-sdl:Xonotic/xonotic-linux64-sdl darkplaces-dedicated:Xonotic/xonotic-linux64-dedicated'
881 "$SELF" release-engine-win32 &
882 "$SELF" release-engine-win64 &
883 "$SELF" release-engine-osx &
884 "$SELF" release-engine-linux32 &
885 "$SELF" release-engine-linux64 &
890 for X in data/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
892 cd Xonotic/data/xonotic-maps.pk3dir
899 # version numnber and stuff like that
902 verbose make -C Xonotic/data/xonotic-data.pk3dir FTEQCC="$d0/Xonotic/fteqcc/fteqcc.linux32" FTEQCCFLAGS_WATERMARK=
904 release-buildpk3-transform-raw)
907 release-buildpk3-transform-normal)
910 # texture: convert to jpeg and dds
912 export jpeg_qual_rgb=95
913 export jpeg_qual_a=99
917 find textures -type f -print0 | xargs -0 "$d0"/misc/tools/cached-converter.sh
919 release-buildpk3-transform-low)
922 # texture: convert to jpeg and dds
923 # music: reduce bitrate
925 export jpeg_qual_rgb=95
926 export jpeg_qual_a=99
930 find textures sound/cdtracks -type f -print0 | xargs -0 "$d0"/misc/tools/cached-converter.sh
944 rsync --exclude=.git -vaSHPAX "$src"/ "Xonotic/temp"
945 "$SELF" release-buildpk3-transform-$transform "Xonotic/temp"
947 zip -9r "../../$dst" . ########### 7za a -tzip -mx=9 "../../$dst" .
954 while [ "$#" -gt 1 ]; do
955 "$SELF" release-buildpk3 "$src" "Xonotic/${src%.pk3dir}$2.pk3" "$1"
961 "$SELF" release-buildpk3s data/font-dejavu.pk3dir raw ''
962 "$SELF" release-buildpk3s data/xonotic-data.pk3dir normal '' raw '-raw' low '-low'
963 "$SELF" release-buildpk3s data/xonotic-maps.pk3dir normal '' raw '-raw' low '-low'
964 "$SELF" release-buildpk3s data/xonotic-music.pk3dir normal '' raw '-raw' low '-low'
965 "$SELF" release-buildpk3s data/xonotic-nexcompat.pk3dir low ''
968 "$SELF" release-prepare
970 "$SELF" release-finish
973 "$SELF" release-engine
979 echo " $SELF push [-s]"
980 echo " $SELF branches"
981 echo " $SELF branch [<remote>] <branchname>"
982 echo " $SELF branch <remote> <branchname> <srcbranchname>"
983 echo " $SELF checkout [<remote>] <branchname>"
984 echo " $SELF compile [-c|-n] [<client>] <options>"
985 echo " $SELF run [<client>] <options>"
986 echo " $SELF each <command>"